"""
Module for checking raw artefact assets against compliance standards.

This module provides the `CheckRawArtefactAsset` class, which is used to
validate raw artefact assets to ensure they meet the required standards,
specifically checking if assets are valid tarballs.

Classes:
    CheckRawArtefactAsset: A class that performs validation on raw artefact
        assets.
"""

import tarfile

from ska_cicd_artefact_validations.core.artefact import Artefact, ArtefactType
from ska_cicd_artefact_validations.core.check import Check
from ska_cicd_artefact_validations.core.message_generator import MessageType


class CheckRawArtefactAsset(Check):
    """
    A class that performs validation on raw artefact assets.

    This class checks raw artefact assets to ensure they are valid tarballs.
    It logs errors and provides mitigation strategies if the asset is
    non-compliant.

    Attributes:
        feature_toggle: The feature toggle associated with this check.
        valid: A boolean indicating whether the artefact's assets are valid.
    """

    feature_toggle = "check-raw-artefact-asset"

    def __init__(self):
        self.valid = True

    async def check(self, artefact: Artefact) -> bool:
        """
        Checks if the raw artefact assets are valid tarballs.

        This method validates each asset of the artefact to ensure they are
        tar files, specifically targeting artefacts of type RAW.

        :param artefact: The artefact whose assets are to be validated.
        :return: True if all assets are valid tarballs, otherwise False.
        """
        if artefact.type == ArtefactType.RAW:
            for asset in artefact.assets:
                if not tarfile.is_tarfile(asset):
                    self.valid = False

        return self.valid

    async def type(self) -> MessageType:
        """
        Returns the type of message generated by this check.

        :return: MessageType.FAILURE indicating a failed compliance check.
        """
        return MessageType.FAILURE

    async def description(self) -> str:
        """
        Provides a description of the raw artefact asset compliance check.

        :return: A string describing the nature of the check failure.
        """
        return "Non-compliant Raw Artefact Asset"

    async def mitigation_strategy(self) -> str:
        """
        Provides a mitigation strategy if the raw artefact asset is
        non-compliant.

        This method guides the user on how to correct the raw artefact asset
        by ensuring it is a valid tarball.

        :return: A string with the mitigation strategy and a link to the
            relevant guidelines.
        """
        return (
            "Raw artefact is an invalid tarball (tar.gz)! Please refer to "
            "[the developer portal](https://developer.skatelescope.org/en/latest/tools/software-package-release-procedure.html#raw) "  # pylint: disable=line-too-long # noqa: E501
            "to correct this issue."
        )
